//---------------------------------------------------------------------------
//  (c)Alex A. Trubetskoy        alextr438@yandex.ru
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "BoxesManage.h"
#include "Properties.h"
#include "MailBox.h"
#include "const.h"                  //constants

#pragma package(smart_init)
//---------------------------------------------------------------------------
TBoxesManager::TBoxesManager() : fCountBoxes(0), activeBox(-1)
{
}
//---------------------------------------------------------------------------
// create new box
//---------------------------------------------------------------------------
bool TBoxesManager::createBox(TFormProperties *pfp) {
   boxes.resize(++fCountBoxes);
   AnsiString list[COUNT_FEATURES];
   list[NAME] = pfp->edName->Text;
   list[EMAIL] = pfp->edEmail->Text;
   list[PASSW] = pfp->edPassw->Text;
   list[POP] = pfp->edPOP->Text;
   list[SMTP] = pfp->edSMTP->Text;
   list[DEL] = (pfp->cbDelMess->Checked ? "y" : "n");
   list[PATH] = pfp->edPath->Text;
   boxes[fCountBoxes - 1] = new TMailBox(list, pfp->cbDelMess->Checked);

   if(!boxes[fCountBoxes - 1]->createBox()) {
      --fCountBoxes;
      delete boxes[fCountBoxes];
      return false;
   }
   activeBox = 0;
   return true;
}
//---------------------------------------------------------------------------
bool TBoxesManager::restoreBox(AnsiString* list, bool del)
{
   boxes.resize(++fCountBoxes);
   boxes[fCountBoxes - 1] = new TMailBox(list, del);
   activeBox = 0;
   return true;
}
//---------------------------------------------------------------------------
TBoxesManager::~TBoxesManager() {
   for(int i = 0; i < fCountBoxes; ++i) {
      if(boxes[i])
         delete boxes[i];
   }
}
//---------------------------------------------------------------------------
// count of boxes
//---------------------------------------------------------------------------
int TBoxesManager::getCountBoxes()const {
   return fCountBoxes;
}
//---------------------------------------------------------------------------
int TBoxesManager::getActiveBoxIndex()const {
   return activeBox;
}
//---------------------------------------------------------------------------
const TMailBox* TBoxesManager::getActiveBox()const {
   return boxes[activeBox];
}
//---------------------------------------------------------------------------
void __fastcall TBoxesManager::setActiveBox(int num) {
   activeBox = num;
}
//---------------------------------------------------------------------------
AnsiString TBoxesManager::getPathOfActiveBox()const {
   return boxes[activeBox]->path;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TBoxesManager::getPathOfBox(int num)const
{
   if((unsigned)num < boxes.size())
      return boxes[num]->path;
   return "-1";
}
