//---------------------------------------------------------------------------
//  (c)Alex A. Trubetskoy        alextr438@yandex.ru
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "FormEditMessageUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormEditMessage *FormEditMessage;
//---------------------------------------------------------------------------
__fastcall TFormEditMessage::TFormEditMessage(TComponent* Owner)
   : TForm(Owner)
{
   //show the form's button on the taskbar
   LONG exstyle = GetWindowLong(Handle, GWL_EXSTYLE);
   exstyle |= WS_EX_APPWINDOW;
   SetWindowLong(Handle, GWL_EXSTYLE, exstyle);
}
//---------------------------------------------------------------------------
void __fastcall TFormEditMessage::actionSaveExecute(TObject *Sender)
{
   AnsiString path = fPath + "Outbox\\message.spmg";
   int hFile;
   if(FileExists(path)) {
      if((hFile = FileOpen(path, fmOpenWrite)) == -1) {
         MessageBox(NULL, "Unable to open message file  ", "Error", MB_ICONSTOP);
         return;
      }
      FileSeek(hFile, 0, 2);
   }
   else {
      if((hFile = FileCreate(path)) == -1) {
         MessageBox(NULL, "Unable to create message file  ", "Error", MB_ICONSTOP);
         return;
      }
   }

   AnsiString buf = AnsiString("beginofmessagesp") + "\n" + "message id" + "\n" +
                    edFrom->Text + "\n" + edTo->Text +
                    "\n" + edSubject->Text + "\n" + DateToStr(Date()) + "\n" +
                    memoMessage->Text +
                    (char)0x01 + "endofmessagesp" + (char)0x01 + "\n\n\n";

   if(FileWrite(hFile, buf.c_str(), buf.Length()) == -1) {
      MessageBox(NULL, "Unable write data to message file  ", "Error", MB_ICONSTOP);
   }
   FileClose(hFile);
}
//---------------------------------------------------------------------------
void __fastcall TFormEditMessage::setPath(AnsiString str) {
   if(fPath != str)
      fPath = str;
}
//---------------------------------------------------------------------------

void __fastcall TFormEditMessage::actionExitExecute(TObject *Sender)
{
   Close();   
}
//---------------------------------------------------------------------------

