//---------------------------------------------------------------------------
//  (c)Alex A. Trubetskoy        alextr438@yandex.ru
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "GetMessThread.h"
#include "Main.h"
#include "BoxesManage.h"
#include "FormConnectUnit.h"
#include "SpMessage.h"
#include "const.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TGetMessThread::TGetMessThread(bool CreateSuspended)
   : TThread(CreateSuspended), get(true)
{
}
//---------------------------------------------------------------------------
void __fastcall TGetMessThread::Execute()
{
    if(get)
        Synchronize(getMessagesThread);
    else
        Synchronize(sendMessagesThread);
}
//---------------------------------------------------------------------------
void __fastcall TGetMessThread::getMessagesThread() {
   int hFileIn, hFileReceived, lenFileReceived;
   AnsiString pathReceived, temp;
   TStringList* ids = new TStringList();  //array contains message ids

   FormConnect->labelReport->Caption = "Connecting to the server...";
   FormConnect->labelNumMess->Caption = "";
   FormConnect->progressBar->Position = 0;
   try {
      if((MainForm->pm->getActiveBoxIndex()) == -1) {
         MessageBox(NULL, "There is no selected boxes", "Warning",
                 MB_ICONINFORMATION);
         return;
      }

      const TMailBox* pBox = MainForm->pm->getActiveBox();
      FormConnect->nmPOP3->AttachFilePath = MainForm->pm->getPathOfActiveBox()
                                            + "Inbox\\";
      FormConnect->Show();

      if(FormConnect->nmPOP3->Connected)
         FormConnect->nmPOP3->Disconnect();
      //create the connection
      FormConnect->nmPOP3->Password = pBox->password;
      FormConnect->nmPOP3->Host = pBox->popServer;
      FormConnect->nmPOP3->UserID = pBox->emailAddress;
      FormConnect->nmPOP3->Connect();
      Sleep(1000);

      //check the current count of messages
      FormConnect->labelReport->Caption = "Getting number of messages...";
      int countMess = FormConnect->nmPOP3->MailCount;
      Sleep(1000);

      FormConnect->labelReport->Caption = ("There are " + IntToStr(countMess)
                              + " messages in your mailbox");
      if (countMess > 0) {                //there are some new letters
         FormConnect->progressBar->Min = 0;
         FormConnect->progressBar->Max = countMess;
         AnsiString list[COUNT_MESS_FIELDS];
         AnsiString pathIn;
         int itemp, count;
         //open message file to put messages there
         pathIn = MainForm->pm->getPathOfActiveBox() + "Inbox\\message.spmg";
         pathReceived = MainForm->pm->getPathOfActiveBox() + "Inbox\\received.spr";
         hFileIn = getHFileToWrite(pathIn);
         hFileReceived = getHFileToRead(pathReceived, lenFileReceived);

         //get ids of messages that were received earlier & put them to StringList
         if(hFileReceived != -1) {
            char* pszBuffer = new char[lenFileReceived + 1];
            FileRead(hFileReceived, pszBuffer, lenFileReceived);
            FileClose(hFileReceived);
            for(int i = 0; i < lenFileReceived; ++i) {
               while(pszBuffer[i] == '\n' && i < lenFileReceived) ++i;
               while(pszBuffer[i] != '\n' && i < lenFileReceived)
                  temp += pszBuffer[i++];
               ids->Add(temp);
               temp = "";
            }
            delete[] pszBuffer;
         }

         //get messages
         bool wasReceived;
         for(int i = 1; i <= countMess; ++i) {
            wasReceived = false;
            FormConnect->labelNumMess->Caption = "Receiving " + IntToStr(i) +
                                        " message";
            FormConnect->nmPOP3->GetMailMessage(i);

            //check if the message was received earlier; if yes, ignore this message
            list[MESS_ID] = FormConnect->nmPOP3->MailMessage->MessageId;
            int index;
            if(ids->Find(list[MESS_ID], index))
               wasReceived = true;
            for(int k = 0; k < ids->Count; ++k) {
               if(ids->Strings[k].Pos(list[MESS_ID]) != 0) {
                  wasReceived = true;
                  break;
               }
            }
               
            if(!wasReceived) {
               ids->Add(list[MESS_ID]);

               list[MESS_TEXT] = FormConnect->nmPOP3->MailMessage->Body->Text;

               //extract date
               count = FormConnect->nmPOP3->MailMessage->Head->Count;
               list[DATE] = "date is unavailable";
               for(itemp = 0; itemp < count; ++itemp) {
                  temp = FormConnect->nmPOP3->MailMessage->Head->Strings[itemp];
                  if(temp.SubString(1, 4) == "Date") {
                     list[DATE] = temp.SubString(7, temp.Length() - 6);
                     break;
                  }
               }

               //extract "to"
               list[TO] = "the field is unavailable";
               for(itemp = 0; itemp < count; ++itemp) {
                  temp = FormConnect->nmPOP3->MailMessage->Head->Strings[itemp];
                  if(temp.SubString(1, 2) == "To") {
                     list[TO] = temp.SubString(5, temp.Length() - 4);
                     break;
                  }
               }

               list[FROM] = FormConnect->nmPOP3->MailMessage->From;
               list[SUBJECT] = FormConnect->nmPOP3->MailMessage->Subject;

               TSpMessage* p = new TSpMessage(list);
               putMessToFile(p, hFileIn);
               delete p;
               FormConnect->progressBar->Position = i;
            }
         }
         FileClose(hFileIn);

         //put message ids to the file
         if(FileExists(pathReceived)) {
            DeleteFile(pathReceived);
            Sleep(200);
         }
         hFileReceived = FileCreate(pathReceived);
         int k;
         if(lenFileReceived > 32768)
            k = 300;
         else
            k = 0;
         for(; k < ids->Count; ++k) {
            temp = (ids->Strings[k] + "\n");
            FileWrite(hFileReceived, temp.c_str(), temp.Length());
         }
         FileClose(hFileReceived);
         delete ids;
      }
      else {
         ShowMessage("There is no new message in your mailbox! ");
      }
      FormConnect->nmPOP3->Disconnect();
      FormConnect->Hide();
      MainForm->actionTreeClickExecute((TObject*)FormConnect);
   }
   catch(Exception& exc) {
      ShowMessage("Error connection: " + exc.Message);

      //put message ids to the file
      if(FileExists(pathReceived)) {
         DeleteFile(pathReceived);
         Sleep(200);
      }
      hFileReceived = FileCreate(pathReceived);
      int k;
      if(lenFileReceived > 32768)
         k = 300;
      else
         k = 0;
      for(; k < ids->Count; ++k) {
         temp = (ids->Strings[k] + "\n");
         FileWrite(hFileReceived, temp.c_str(), temp.Length());
      }
      FileClose(hFileReceived);
      if(ids)delete ids;

      FileClose(hFileIn);
      FileClose(hFileReceived);
      FormConnect->Hide();
   }
}
//---------------------------------------------------------------------------
void __fastcall TGetMessThread::sendMessagesThread() {
   FormConnect->progressBar->Position = 0;
   FormConnect->labelReport->Caption = "Connecting to the server...";
   FormConnect->labelNumMess->Caption = "";
   try {
      if((MainForm->pm->getActiveBoxIndex()) == -1) {
         MessageBox(NULL, "There is no selected boxes", "Warning",
                 MB_ICONINFORMATION);
         return;
      }
      AnsiString pathOut = MainForm->pm->getPathOfActiveBox() + "Outbox\\message.spmg";
      if(!FileExists(pathOut)) {
         MessageBox(NULL, "There is no message to send", "Warning",
                 MB_ICONINFORMATION);
         return;
      }
      const TMailBox* pBox = MainForm->pm->getActiveBox();

      //retrieve messages from outbox
      AnsiString end;
      AnsiString list[COUNT_MESS_FIELDS];
      int hFileOut, lenFile, countBytes, i = 0, numMess = 1;

      if((hFileOut = getHFileToRead(pathOut, lenFile)) == -1) {
         MessageBox(NULL, "Unable to open message file  ", "Error", MB_ICONSTOP);
         return;
      }
      char* pszBuffer = new char[lenFile + 1];
      vector<TSpMessage*> messOut;      //messages from the outbox
      countBytes = FileRead(hFileOut, pszBuffer, lenFile);
      FileClose(hFileOut);
      while(i < countBytes && pszBuffer[i] == '\n') ++i;

      while(i < countBytes) {
         //ignore "beginofmessagesp" string
         while(i < countBytes && pszBuffer[i] != '\n') ++i;
         while(i < countBytes && pszBuffer[i] == '\n') ++i;
         for(int j = 0; j < COUNT_MESS_FIELDS - 1; ++j) {
            //get string
            while(i < countBytes && pszBuffer[i] != '\n')
               list[j] += pszBuffer[i++];
            while(pszBuffer[i] == '\n') ++i;
         }
         while(i < countBytes && pszBuffer[i] != (char)0x01)
            list[MESS_TEXT] +=  pszBuffer[i++];
         end = "";
         while(i < countBytes && pszBuffer[i] != '\n')
            end += pszBuffer[i++];
         if(strstr(end.c_str(), "endofmessagesp") == NULL) {
            MessageBox(NULL, "The message file is corrupted  ", "Error", MB_ICONSTOP);
            return;
         }
         while(i < countBytes && pszBuffer[i] != '\n') ++i;

         messOut.push_back(new TSpMessage(list));
         ++numMess;

         for(int j = 0; j < COUNT_MESS_FIELDS; ++j)
            list[j] = "";
         while(pszBuffer[i] == '\n') ++i;
      }
      delete[] pszBuffer;

      FormConnect->Show();
      if(FormConnect->nmSMTP->Connected)
         FormConnect->nmSMTP->Disconnect();
      //create the connection
      FormConnect->nmSMTP->Host = pBox->smtpServer;
      int dog = pBox->emailAddress.Pos("@");
      FormConnect->nmSMTP->UserID = pBox->emailAddress.SubString(1, dog - 1);
      FormConnect->nmSMTP->Connect();
      Sleep(1000);

      int hFileSent;
      AnsiString buf;
      AnsiString pathSent = MainForm->pm->getPathOfActiveBox() + "Sent\\message.spmg";
      if((hFileSent = getHFileToWrite(pathSent)) == -1) {
         FormConnect->nmSMTP->Disconnect();
         FormConnect->Hide();
         return;
      }

      //send messages
      for(unsigned i = 0; i < messOut.size(); ++i) {
         FormConnect->labelNumMess->Caption = "Sending " + IntToStr(i) +
                                        " message";
         FormConnect->nmSMTP->PostMessage->FromAddress = pBox->emailAddress;
         FormConnect->nmSMTP->PostMessage->FromName = pBox->emailAddress.SubString(1, dog - 1);
         FormConnect->nmSMTP->PostMessage->Subject = messOut[i]->subject;
         FormConnect->nmSMTP->PostMessage->ToAddress->Add(messOut[i]->to);
         //FormConnect->nmSMTP->PostMessage->Attachments->Text = "";
         FormConnect->nmSMTP->PostMessage->Body->Add(messOut[i]->text);
         FormConnect->nmSMTP->SendMail();

         messOut[i]->date = DateToStr(Date());
         messOut[i]->messId = "-1";
         putMessToFile(messOut[i], hFileSent);
         messOut[i]->reserved = true;

         FormConnect->nmSMTP->PostMessage->Body->Clear();
         FormConnect->nmSMTP->PostMessage->ToAddress->Clear();
      }
      FileClose(hFileSent);

      //check if all messages were sent; if no, put them back to the outbox
      DeleteFile(pathOut);
      hFileOut = -1;
      for(unsigned i = 0; i < messOut.size(); ++i) {
         if(!messOut[i]->reserved) {
            if(hFileOut == -1) {
               if((hFileOut = FileCreate(pathOut)) == -1) {
                  MessageBox(NULL, "Unable to create new message file for outbox ", "Error", MB_ICONSTOP);
                  break;
               }
            }
            putMessToFile(messOut[i], hFileOut);
         }
      }
      if(hFileOut != -1)
         FileClose(hFileOut);

      FormConnect->nmSMTP->Disconnect();
      FormConnect->Hide();
   }
   catch(Exception& exc) {
      ShowMessage("Error connection: " + exc.Message);
      FormConnect->Hide();
   }
}
//---------------------------------------------------------------------------
void __fastcall TGetMessThread::putMessToFile(TSpMessage* pMess, int hFile)
{
   AnsiString buf = AnsiString("beginofmessagesp") + "\n" + pMess->messId + "\n" +
                    pMess->from + "\n" + pMess->to +
                    "\n" + pMess->subject + "\n" + pMess->date + "\n" +
                    pMess->text +
                    (char)0x01 + "endofmessagesp" + (char)0x01 + "\n\n\n";

   if(FileWrite(hFile, buf.c_str(), buf.Length()) == -1) {
      MessageBox(NULL, "Unable write data to message file  ", "Error", MB_ICONSTOP);
   }
}
//---------------------------------------------------------------------------
int __fastcall TGetMessThread::getHFileToWrite(AnsiString path)
{
   int hFile;
   if(FileExists(path)) {
      if((hFile = FileOpen(path, fmOpenWrite)) == -1) {
         MessageBox(NULL, "Unable to open message file  ", "Error", MB_ICONSTOP);
         Terminate();
      }
      FileSeek(hFile, 0, 2);
   }
   else {
      if((hFile = FileCreate(path)) == -1) {
         MessageBox(NULL, "Unable to create message file  ", "Error", MB_ICONSTOP);
         Terminate();
      }
   }
   return hFile;
}
//---------------------------------------------------------------------------
int __fastcall TGetMessThread::getHFileToRead(AnsiString path, int& len)
{
   int hFile = -1;
   len = 0;
   if(FileExists(path)) {
      if((hFile = FileOpen(path, fmOpenRead)) != -1) {
         len = FileSeek(hFile, 0, 2);
         FileSeek(hFile, 0, 0);
      }
   }
   return hFile;
}
//---------------------------------------------------------------------------
