//---------------------------------------------------------------------------
//  (c)Alex A. Trubetskoy        alextr438@yandex.ru
//---------------------------------------------------------------------------
#include <Filectrl.hpp>
#pragma hdrstop
#include "MailBox.h"
#include "GetMessThread.h"
#include "const.h"                  //constants

TGetMessThread* pThread;

//---------------------------------------------------------------------------
TMailBox::TMailBox(AnsiString* list, bool del)
         : fName(list[NAME]), fEmailAddress(list[EMAIL]), fPassword(list[PASSW]),
           fPopServer(list[POP]), fSmtpServer(list[SMTP]), fPath(list[PATH]),
           fDelMessage(del)
{
   if(fPath[fPath.Length()] != '\\')
      fPath += '\\';
}
//---------------------------------------------------------------------------
// the function creates new box (creates folders & put the information to the
// configuration file
//---------------------------------------------------------------------------
bool TMailBox::createBox()
{
   if(DirectoryExists(fPath + fName)) {
      AnsiString mess = "Directory " + fPath + fName + " already exists!"
                        + " Please use another path. ";
      MessageBox(NULL, mess.c_str(), "Error", MB_ICONINFORMATION);
      return false;
   }

   int hFile;
   if(!FileExists("config.spcf")) {
      if((hFile = FileCreate("config.spcf")) == -1) {
         MessageBox(NULL, "Unable to create the configuration file  ",
                    "Error", MB_ICONSTOP);
         return false;
      }
   }
   else
   if((hFile = FileOpen("config.spcf", fmOpenReadWrite)) == -1) {
      MessageBox(NULL, "Unable to open the configuration file  ",
                 "Error", MB_ICONSTOP);
      return false;
   }

   if(!ForceDirectories(fPath + fName)) {
      MessageBox(NULL, "Can't create directory!  ", "Error", MB_ICONSTOP);
      return false;
   }
   if(!CreateDir(fPath + fName + "\\Inbox") ||
      !CreateDir(fPath + fName + "\\Outbox") ||
      !CreateDir(fPath + fName + "\\Sent") ||
      !CreateDir(fPath + fName + "\\Trash") ||
      !CreateDir(fPath + fName + "\\Drafts"))
   {
      MessageBox(NULL, "Internal error  ", "Error", MB_ICONSTOP);
      return false;
   }
   
   AnsiString delStr = fDelMessage ? "y" : "n";
   AnsiString buf = fName + "\n" + fEmailAddress + "\n" + fPassword + "\n" +
                    fPopServer + "\n" + fSmtpServer + "\n" + delStr + "\n" +
                    fPath + "\n\n\n";
   FileSeek(hFile, 0, 2);
   if(FileWrite(hFile, buf.c_str(), buf.Length()) == -1) {
      MessageBox(NULL, "Internal error  ", "Error", MB_ICONSTOP);
      FileClose(hFile);
      return false;
   }
   FileClose(hFile);
   return true;
}
//---------------------------------------------------------------------------
void TMailBox::deleteBox() {
   //delete directories
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setName(AnsiString str) {
   if(fName != str)
      fName = str;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailBox::getName()const {
   return fName;
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setEmailAddress(AnsiString str) {
   if(fEmailAddress != str)
      fEmailAddress = str;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailBox::getEmailAddress()const {
   return fEmailAddress;
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setPassword(AnsiString passw) {
   if(fPassword != passw)
      fPassword = passw;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailBox::getPassword()const {
   return fPassword;
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setPopServer(AnsiString str) {
   if(fPopServer != str)
      fPopServer = str;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailBox::getPopServer()const {
   return fPopServer;
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setSmtpServer(AnsiString str) {
   if(fSmtpServer != str)
      fSmtpServer = str;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailBox::getSmtpServer()const {
   return fSmtpServer;
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setPath(AnsiString str) {
   if(fPath != str)
      fPath = str;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMailBox::getPath()const {
   return (fPath + fName + '\\');
}
//---------------------------------------------------------------------------
int __fastcall TMailBox::getCountMess()const {
   return fCountMess;
}
//---------------------------------------------------------------------------
void __fastcall TMailBox::setDel(bool val) {
   fDelMessage = val;
}
//---------------------------------------------------------------------------
bool __fastcall TMailBox::getDel()const {
   return fDelMessage;
}
//---------------------------------------------------------------------------
